﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Private Sub Class_Globals
	Private fx As JFX
	Private this As Toast = Me
	
	Private mTooltip As JavaObject
	
	Private mOwnerForm 			As Form
	Private mCallbackModule As Object = Null
	Private mCallback 			As String = ""

	Private mTimerOn 	As Timer
	Private mTimerOff As Timer
	Private mTimeOn 	As Long = 300
	Private mtimeOff 	As Long = 4000
	Private mUseTimer As Boolean = False
	
	Private mUseFade As Boolean = False
	Private mFadeIn  As Double 	= 0.01
	Private mFadeOut As Double	= 0.01	
	
	Private mX 					 As Double
	Private mY 					 As Double
	Private mOffsetX		 As Double
	Private mOffsetY 		 As Double
	Private mWhereToShow As Int
	Private mDecorTop 	 As Double
	Private mDecorLeft 	 As Double

	Private mSavedOpacity  	As Double
	Private mCurrentOpacity As Double

	Private mIsTiming  As Boolean = False
	Private mIsShowing As Boolean = False
	
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'		TEMP	
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'	Private sTime As Long
	
End Sub

Private Sub TimerOn_Tick
	
	If mUseFade Then
		
		If mTimerOn.Interval > 1 Then
		  mTimerOn.Interval = 1
			mSavedOpacity = this.Opacity
			mCurrentOpacity = 0
			this.Opacity = 0
			ShowmTooltip
'			sTime = DateTime.Now

		End If		
		
	 	mCurrentOpacity = mCurrentOpacity + mFadeIn
	  If mCurrentOpacity + mFadeIn > mSavedOpacity Then mCurrentOpacity = mSavedOpacity
		this.Opacity = mCurrentOpacity
				
		If mCurrentOpacity < mSavedOpacity Then Return
		
		this.Opacity = mSavedOpacity
'		Log("Fade In=" & (DateTime.Now - sTime))
		
	Else
				
		ShowmTooltip		
	
	End If
	
	mTimerOn.Enabled = False
	mTimerOn.Interval = mTimeOn
	mTimerOff.Enabled = True
	
End Sub

Private Sub TimerOff_Tick
	
	If mUseFade Then
		
		If mTimerOff.Interval > 1 Then
			mTimerOff.Interval = 1
			mSavedOpacity = this.Opacity
			mCurrentOpacity = mSavedOpacity
'			sTime = DateTime.Now
		End If				
		 
	 	mCurrentOpacity = mCurrentOpacity - mFadeOut
	  If mCurrentOpacity - mFadeOut < 0 Then mCurrentOpacity = 0
		this.Opacity = mCurrentOpacity
		If mCurrentOpacity > 0 Then Return
			
		this.Opacity = mSavedOpacity
'		Log("Fade Out=" & (DateTime.Now - sTime))
	
	End If	

	mTimerOff.Enabled = False
	mTimerOff.Interval = mtimeOff
	Hide
	mIsTiming = False
	RunCallback(mIsTiming)
		
End Sub

Private Sub ShowmTooltip
		
	If mUseTimer Then RunCallback(mIsTiming)
	
	mIsShowing = True
		
	mTooltip.RunMethod("show", Array(mOwnerForm.RootPane, mX, mY))

	Select mWhereToShow

		Case SHOW_AT_CENTER_OWNER
			this.AnchorX = mOwnerForm.WindowLeft + (mOwnerForm.WindowWidth  - this.Width)  * 0.5 + mDecorLeft
			this.AnchorY = mOwnerForm.WindowTop  + Abs((mOwnerForm.WindowHeight - this.Height) * 0.5) + mDecorTop			
'			this.AnchorX = mOwnerForm.WindowLeft + Abs((mOwnerForm.WindowWidth  - this.Width)  * 0.5) + mDecorLeft
'			this.AnchorY = mOwnerForm.WindowTop  + Abs((mOwnerForm.WindowHeight - this.Height) * 0.5) + mDecorTop

		Case SHOW_AT_CENTER_SCREEN
			this.X = mX - this.Width  * 0.5
			this.y = mY - this.Height * 0.5

		Case Else
			
	End Select
	
End Sub

Private Sub RunCallback(Result As Boolean)
	If SubExists(mCallbackModule, mCallback) Then 
		CallSub2(mCallbackModule, mCallback, Result)
	End If
End Sub

'Initializes Toast..
'Text can be "". Can set it later.
Public Sub Initialize(ParentForm As Form, Text As String)
	
	mOwnerForm = ParentForm
	
	Dim jo As JavaObject = ParentForm
	mDecorLeft = jo.GetFieldJO("scene").RunMethod("getX",Null)
	mDecorTop  = jo.GetFieldJO("scene").RunMethod("getY",Null)
	
	mTimerOn.Initialize ("TimerOn",  mTimeOn)
	mTimerOff.Initialize("TimerOff", mtimeOff)

	mTooltip.InitializeNewInstance("javafx.scene.control.Tooltip", Array(Text))
	
	mTooltip.RunMethod("setAutoFix", Array(False))
	
End Sub

#Region PROPERTIES
'Tooltip Reference
Public Sub getToast As Object
	Return mTooltip
End Sub
'Set to True if want use fade in and fade out
'If want fade only, can set time in and time out to 0
Public Sub setUseFade(uf As Boolean)
	mUseFade = uf
End Sub
'Fade in time in milliseconds
Public Sub setFadeIn(fi As Double)
	If fi < 1 Then fi = 1
	mFadeIn = 1 / (fi * 0.1)
End Sub
'Fade out time in milliseconds
Public Sub setFadeOut(fo As Double)
	If fo < 1 Then fo = 1
	mFadeOut = 1 / (fo * 0.1)
End Sub
'Set to True if want use time in and time out
Public Sub setUseTimer(ut As Boolean)
	
	mUseTimer = ut
	
	If mUseTimer Then
		
		If this.IsActivated Then mTimerOff.Enabled = True
	
	End If
	
End Sub
'Time In in milliseconds
Public Sub setTimeOn(tmOn As Long)
	If tmOn < 2 Then tmOn = 2
'	If mTimerOn.Enabled Then mTimerOn.Interval = mTimeOn
	mTimeOn = tmOn	
End Sub
'Time Out in milliseconds
Public Sub setTimeOff(tmOff As Long)
	If tmOff < 2 Then tmOff = 2
	mtimeOff = tmOff	
End Sub
'Shift the Toast horizontal position
'by the given value
Public Sub setOffsetX(ox As Double)
	mOffsetX = ox
	setX(getX + ox)
End Sub
'Shift the Toast vertical position
'by the given value
Public Sub setOffsetY(oy As Double)
	mOffsetY = oy
	setY(getY + oy )	
End Sub

Public Sub getAnchorX As Double
	Return mTooltip.RunMethod("getAnchorX",Null)
End Sub
Public Sub setAnchorX(ax As Double)
	mTooltip.RunMethod("setAnchorX", Array(ax))
End Sub

Public Sub getAnchorY As Double
	Return mTooltip.RunMethod("getAnchorY",Null)
End Sub
Public Sub setAnchorY(ay As Double)
	mTooltip.RunMethod("setAnchorY", Array(ay))
End Sub
'Check whether Toast is activated
Public Sub getIsActivated As Boolean
	Return mTooltip.RunMethod("isActivated", Null)
End Sub
'Check whether Toast is visible
Public Sub getIsShowing As Boolean
	Return mIsShowing
End Sub

Public Sub getIsWrapText As Boolean
	Return mTooltip.RunMethod("isWrapText", Null)
End Sub

'<code>"BOTTOM"</code>
' Content will be placed at the bottom of the Label.
'<code>"CENTER"</code>
' Content will be placed at the center of the Label.
'<code>"GRAPHIC_ONLY"</code>
' Only the content will be displayed.
'<code>"LEFT"</code>
' Content will be placed at the left of the Label.
'<code>"RIGHT"</code>
' Content will be placed at the right of the Label.
'<code>"TEXT_ONLY"</code>
' Only the label's text will be displayed.
'<code>"TOP"</code>
' Content will be placed at the top of the Label.
Public Sub getContentDisplay As String
	Return mTooltip.RunMethod("getContentDisplay", Null)
End Sub
Public Sub setContentDisplay(cd As String)
	mTooltip.RunMethod("setContentDisplay", Array(cd))
End Sub

Public Sub getFont As Font
	Return mTooltip.RunMethod("getFont", Null)
End Sub
Public Sub setFont(f As Font)
	mTooltip.RunMethod("setFont", Array(f))
End Sub

'Gets or sets the the graphic that will be set at
'ContentDisplay position. It can be a node or an image
Public Sub getGraphic As Object
	Return mTooltip.RunMethod("getGraphic", Null)
End Sub
Public Sub setGraphic(g As Object)
	If g Is Image Then
		Dim img As ImageView
		img.Initialize("")
		img.SetImage(g)
		g = img
	End If
	mTooltip.RunMethod("setGraphic", Array(g))
End Sub

Public Sub getGraphicTextGap As Double
	Return mTooltip.RunMethod("getGraphicTextGap", Null)
End Sub
Public Sub setGraphicTextGap(gtg As Double)
	mTooltip.RunMethod("setGraphicTextGap", Array(gtg))
End Sub

Public Sub getHeight As Double
	Return mTooltip.RunMethod("getHeight", Null)
End Sub
Public Sub setHeight(h As Double)
	mTooltip.RunMethod("setHeight", Array(h))
End Sub

Public Sub getOpacity As Double
	Return mTooltip.RunMethod("getOpacity", Null)
End Sub
Public Sub setOpacity(o As Double)
	mTooltip.RunMethod("setOpacity", Array(o))
End Sub

Public Sub getStyle As String
	Return mTooltip.RunMethod("getStyle", Null)
End Sub
Public Sub setStyle(s As String)
	mTooltip.RunMethod("setStyle", Array(s))
End Sub

Public Sub getStyleClass As List
	Return mTooltip.RunMethod("getStyleClass", Null)
End Sub

Public Sub getTag As Object
	Return mTooltip.RunMethod("getUserData", Null)
End Sub
Public Sub setTag(t As Object)
	mTooltip.RunMethod("setUserData", Array(t))
End Sub

Public Sub getText As String
	Return mTooltip.RunMethod("getText", Null)
End Sub
Public Sub setText(t As String)
	mTooltip.RunMethod("setText", Array(t))
End Sub

'<code>"CENTER"</code>
' Represents centered text alignment (ragged left and right).
'<code>"JUSTIFY"</code>
' Represents justified text alignment.
'<code>"LEFT"</code>
' Represents text alignment to the left (left-justified, ragged right).
'<code>"RIGHT"</code>
' Represents text alignment to the right (right-justified, ragged left).
Public Sub getTextAlignment As String
	Return mTooltip.RunMethod("getTextAlignment", Null)
End Sub
Public Sub setTextAlignment(ta As String)
	mTooltip.RunMethod("setTextAlignment", Array(ta))
End Sub

Public Sub setTextSize(ts As Double)
	Dim mFont As JavaObject = getFont
	setFont(mFont.RunMethod("font", Array(ts)))
End Sub

'<code>"CENTER_ELLIPSIS"</code>
' Trims out the center of the string being displayed and replaces the middle three characters with "...".
'<code>"CENTER_WORD_ELLIPSIS"</code>
' Same as CENTER_ELLIPSIS but ensures that the "..." occurs between full words.
'<code>"CLIP"</code>
' Any text which exceeds the bounds of the label will be clipped.
'<code>"ELLIPSIS"</code>
' If the text of the label exceeds the bounds of the label, then the last three characters which can be displayed will be "...".
'<code>"LEADING_ELLIPSIS"</code>
' Same as ELLIPSIS but puts the "..." at the beginning of the text instead of at the end
'<code>"LEADING_WORD_ELLIPSIS"</code>
' Same as WORD_ELLIPSIS but puts the "..." at the beginning of the text instead of at the end
'<code>"WORD_ELLIPSIS"</code>
' Same as ELLIPSIS, but first removes any partial words at the label boundary and then applies the ellipsis.
Public Sub getTextOverrun As String
	Return mTooltip.RunMethod("getTextOverrun", Null)
End Sub
Public Sub setTextOverrun(Tov As String)
	mTooltip.RunMethod("setTextOverrun", Array(Tov))
End Sub

Public Sub getWidth As Double
	Return mTooltip.RunMethod("getWidth", Null)
End Sub
Public Sub setWidth(w As Double)
	mTooltip.RunMethod("setWidth", Array(w))
End Sub

Public Sub setWrapText(wt As Boolean)
	mTooltip.RunMethod("setWrapText", Array(wt))
End Sub

Public Sub getX As Double
	Return mTooltip.RunMethod("getX", Null)
End Sub
Public Sub setX(x As Double)
	mTooltip.RunMethod("setX", Array(x + mOffsetX))
End Sub

Public Sub getY As Double
	Return mTooltip.RunMethod("getY", Null)
End Sub
Public Sub setY(y As Double)
	mTooltip.RunMethod("setY", Array(y + mOffsetY))
End Sub

#End Region

#Region PUBLIC METHODS
'Convenience method to run any other method
' in the tooltip, not present here
Public Sub Run(Method As String, Args() As Object) As Object
	Return mTooltip.RunMethod(Method, Args)
End Sub
'Same as run but return Javaobject
Public Sub Runjo(Method As String, Args() As Object) As JavaObject
	Return mTooltip.RunMethod(Method, Args)
End Sub

'Where to Show:
'SHOW_AT_XY, SHOW_AT_CENTER_OWNER, SHOW_AT_CENTER_SCREEN
'In the last two cases: x, y and relative offsets will be ignored
Public Sub Show(x As Double, y As Double, WhereToShow As Int)
	
	mWhereToShow = WhereToShow
	
	Select WhereToShow
		
		Case SHOW_AT_CENTER_OWNER
			mX = mOwnerForm.WindowLeft 
			mY = mOwnerForm.WindowTop  + mOwnerForm.WindowHeight * 0.25
			
		Case SHOW_AT_CENTER_SCREEN
			mX = fx.PrimaryScreen.MaxX * 0.5
			mY = fx.PrimaryScreen.MaxY * 0.5			
	
		Case Else	
			mX = x + mOffsetX 
			mY = y + mOffsetX	
			
	End Select
	
	If mIsTiming Then Return
	
	If mUseTimer Then
		
		mIsTiming = True

		mTimerOn.Enabled = True
	
	Else
		
	 	ShowmTooltip
	
	End If
	
End Sub

'Close the Toast immediately
Public Sub Hide
	
	If mIsTiming Then
		mTimerOn.Enabled = False
		mTimerOff.Enabled = False
		mTimerOn.Interval = mTimeOn
		mTimerOff.Interval = mtimeOff
		mIsTiming = False
		this.Opacity = mSavedOpacity
		RunCallback(mIsTiming)
	End If
	
	mTooltip.RunMethod("hide", Null)
	
	mIsShowing = False

End Sub
'The sub in CallbackSub will be called once the
'timer and the fade functions ends. If them setted
Public Sub Callback(Module As Object, CallbackSub As String)
	mCallbackModule = Module
	mCallback = CallbackSub	& "_Result"
End Sub

#End Region

#Region PSEUDO CONSTANTS
'Where to Show
Public Sub SHOW_AT_XY As Int :Return 0
End Sub
'Where to Show
Public Sub SHOW_AT_CENTER_OWNER As Int :Return 1
End Sub
'Where to Show
Public Sub SHOW_AT_CENTER_SCREEN As Int :Return 2
End Sub
#End Region